package keskustelubotti;

/**
 * Botin ja kyttliittymn asetukset.
 *
 * Asetuksia on (lhinn) neljn tyyppisi (ja ovat mritelty tss jrjestyksess):
 *
 * (1) String-tekstit; esim. oma nimesi (nick) tai luettavat tiedostot
 *
 * (2) boolean-vaihtoehdot; jokin asia joko on pll tai ei ole, esim. debug-moodi
 *
 * (3) int-keskiarvot ja -hajonnat; jonkin mreen keskiarvo ja keskihajonta, joiden perusteella
 *     arvotaan mreelle joka kerta Gaussitettu normaalijakauman mukainen arvo
 *
 * (4) double-todennkisyydet; jonkin tapahtuman tn 0..1, esim. kirjoitusvirheen todennkisyys
 *
 * Oletusasetukset asetetaan muuttujien esittelyss.
 *
 * Toteutetaan struct-tyyppisen kenttluokkana; kuka tahansa voi muutella asetuksia miten tahtoo.
 * NIIN l sitten sotke niit asetuksia, ettei tule itku.
 *
 * Lisksi toteutettu mahdollisimman hankalasti ja vaivalloisesti, en jaksanut keksi muutakaan, kun
 * ensin koko pivn hajoilin thn homoluokkaan. GRRh.
 *
 * @author Samuli Kaipiainen
 * @version 0.1
 */

public class Asetukset
{
	// "sinun" tekstilaatikossa nytettv nimesi
	String nick = "Min";

	// botin virallinen ja tekstilaatikossa nytettv nimi
	String bottiNimi = "Botti";
	String bottiNick = "Mursubotti";

	// botin "kuva"tiedosto, eli tietoja-ikkunaan ladattava kuva botista (iik)
	String bottiKuvatiedosto = "botti.png";

	// botin sanavarasto (sanatiedosto)
	String sanatiedosto = "sanat.dat";

	// ohjetiedosto (kyttohje)
	String ohjetiedosto = "kyttohje.txt";

	// lauseen parseroinnissa kytettvt sanaerottimet; muut merkit lasketaan sanoiksi
	String sanaerottimet = " \t,.!?:;\"&/()[]{}<>|";

	// ulostetaanko humppainfoja konsoliin tai tilariville
	boolean debugKonsoli = true;
	boolean debugTilarivi = true;

	// botin kirjoitusnopeus (merkki sekunnissa)
	int kirjoitusnopeusKA = 20;
	int kirjoitusnopeusKH = 1;

	// oma-aloitteisen lauseen odotusaika (sekuntia)
	int satunnaisenLauseenOdotusKA = 240;
	int satunnaisenLuaseenOdotusKH = 60;

	// (oma-aloitteisen) lauseen pituus sanoina
	int lauseenPituusKA = 8;
	int lauseenPituusKH = 8;

	// lauseen pituuden vastaavuussuhde vastattavaan lauseeseen (0..1, EI todennkisyys),
	// 0 = arvottu lauseen pituus .. 1 = vastattavan lauseen pituus
	double lauseenVastaavuusSuhde = 0.4;
	// lauseen pituuden vastaavuustodennkisyys vastattavaan lauseeseen,
	// eli mill todennkisyydell vastaavuussuhdetta sovelletaan
	double lauseenVastaavuusTN = 0.6;

	// kirjoitusvirhetodennkisyydet per kirjain, niden summa on tn(virhe), 1-summa on tn(ei virhett)
	double typoPoistoTN = 0.002;  // poisto
	double typoVaihtoTN = 0.002;  // vaihto edellisen kanssa
	double typoMuuttoTN = 0.0004;  // muuttaminen satunnaiseksi
	double typoLisysTN = 0.0004;  // satunnaisen lisys

	// pilkun tn sanan jlkeen
	double pilkkuTN = 0.1;

	// huutomerkin ja kysymysmerkin tn lauseen lopussa, summa on tn(huuto tai kysymys), 1-summa on tn(piste)
	double kysymysTN = 0.08;
	double huutoTN = 0.08;
}
