package keskustelubotti;

import java.util.*;

/**
 * Parseroi annetun lauseen sanoiksi ja lis sanat botin sanavarastoon.
 *
 * @author Samuli Kaipiainen
 * @version 0.1
 */

public class Lauseparseri
{
	private final Sanavarasto sanavarasto;
	private final Asetukset asetukset;

	/**
	 * Luo uuden lauseparserin
	 *
	 * @param sanavarasto Mihin lisilln sanoja
	 * @param asetukset Asetuksista selvi sanaerottimet
	 */
	public Lauseparseri(Sanavarasto sanavarasto, Asetukset asetukset)
	{
		this.sanavarasto = sanavarasto;
		this.asetukset = asetukset;
	}

	/**
	 * Parseroi annetun lauseen ja lis lauseen sanat sanavarastoon
	 *
	 * @param lause Joka parseroidaan
	 * @return Kuinka monta sanaa lauseessa oli
	 */
	public int parseroi(String lause)
	{
		return parseroix(lause)[0];
	}

	/**
	 * Parseroi annetun lauseen ja lis lauseen sanat sanavarastoon;
	 * palauttaa taulukossa sek lauseen kokonaissanamrn ett uusien sanojen mrn
	 *
	 * @param lause Joka parseroidaan
	 * @return { Kuinka monta sanaa lauseessa oli, kuinka monta uutta sanaa lauseessa oli }
	 */
	public int[] parseroix(String lause)
	{
		StringTokenizer st = new StringTokenizer(lause, asetukset.sanaerottimet);
		String sana;
		boolean listtiink;
		int parseroitu = 0, listty = 0;
		StringBuffer parseroitudump = new StringBuffer();

		while (st.hasMoreTokens())
		{
			sana = st.nextToken().toLowerCase();
			listtiink = sanavarasto.lisSana(sana);

			parseroitu++;
			if (listtiink) {
				listty++;
				parseroitudump.append(sana);
			} else
				parseroitudump.append("[" + sana + "]");

			parseroitudump.append(st.hasMoreTokens() ? " " : "");
		}

		Main.debug("parseroitu '" + parseroitudump + "'" +
			   ", listty " + listty + "/" + parseroitu);

		return new int[] { parseroitu, listty };
	}

}
